=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.2.3

=end

require 'cgi'

module PulpFileClient
  class ExportersFileExportsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create an export
    # Trigger an asynchronous task to export a file publication.
    # @param file_filesystem_export_href [String] 
    # @param publication_export [PublicationExport] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def create(file_filesystem_export_href, publication_export, opts = {})
      data, _status_code, _headers = create_with_http_info(file_filesystem_export_href, publication_export, opts)
      data
    end

    # Create an export
    # Trigger an asynchronous task to export a file publication.
    # @param file_filesystem_export_href [String] 
    # @param publication_export [PublicationExport] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def create_with_http_info(file_filesystem_export_href, publication_export, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ExportersFileExportsApi.create ...'
      end
      # verify the required parameter 'file_filesystem_export_href' is set
      if @api_client.config.client_side_validation && file_filesystem_export_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_filesystem_export_href' when calling ExportersFileExportsApi.create"
      end
      # verify the required parameter 'publication_export' is set
      if @api_client.config.client_side_validation && publication_export.nil?
        fail ArgumentError, "Missing the required parameter 'publication_export' when calling ExportersFileExportsApi.create"
      end
      # resource path
      local_var_path = '{file_filesystem_export_href}exports/'.sub('{' + 'file_filesystem_export_href' + '}', CGI.escape(file_filesystem_export_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(publication_export) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ExportersFileExportsApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete an export
    # FilesystemExports provide a history of previous exports.
    # @param file_filesystem_export_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete(file_filesystem_export_href, opts = {})
      delete_with_http_info(file_filesystem_export_href, opts)
      nil
    end

    # Delete an export
    # FilesystemExports provide a history of previous exports.
    # @param file_filesystem_export_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def delete_with_http_info(file_filesystem_export_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ExportersFileExportsApi.delete ...'
      end
      # verify the required parameter 'file_filesystem_export_href' is set
      if @api_client.config.client_side_validation && file_filesystem_export_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_filesystem_export_href' when calling ExportersFileExportsApi.delete"
      end
      # resource path
      local_var_path = '{file_filesystem_export_href}'.sub('{' + 'file_filesystem_export_href' + '}', CGI.escape(file_filesystem_export_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ExportersFileExportsApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List exports
    # FilesystemExports provide a history of previous exports.
    # @param file_file_filesystem_exporter_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [InlineResponse2003]
    def list(file_file_filesystem_exporter_href, opts = {})
      data, _status_code, _headers = list_with_http_info(file_file_filesystem_exporter_href, opts)
      data
    end

    # List exports
    # FilesystemExports provide a history of previous exports.
    # @param file_file_filesystem_exporter_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(InlineResponse2003, Integer, Hash)>] InlineResponse2003 data, response status code and response headers
    def list_with_http_info(file_file_filesystem_exporter_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ExportersFileExportsApi.list ...'
      end
      # verify the required parameter 'file_file_filesystem_exporter_href' is set
      if @api_client.config.client_side_validation && file_file_filesystem_exporter_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_filesystem_exporter_href' when calling ExportersFileExportsApi.list"
      end
      # resource path
      local_var_path = '{file_file_filesystem_exporter_href}exports/'.sub('{' + 'file_file_filesystem_exporter_href' + '}', CGI.escape(file_file_filesystem_exporter_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'InlineResponse2003' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ExportersFileExportsApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect an export
    # FilesystemExports provide a history of previous exports.
    # @param file_filesystem_export_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [ExportResponse]
    def read(file_filesystem_export_href, opts = {})
      data, _status_code, _headers = read_with_http_info(file_filesystem_export_href, opts)
      data
    end

    # Inspect an export
    # FilesystemExports provide a history of previous exports.
    # @param file_filesystem_export_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(ExportResponse, Integer, Hash)>] ExportResponse data, response status code and response headers
    def read_with_http_info(file_filesystem_export_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ExportersFileExportsApi.read ...'
      end
      # verify the required parameter 'file_filesystem_export_href' is set
      if @api_client.config.client_side_validation && file_filesystem_export_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_filesystem_export_href' when calling ExportersFileExportsApi.read"
      end
      # resource path
      local_var_path = '{file_filesystem_export_href}'.sub('{' + 'file_filesystem_export_href' + '}', CGI.escape(file_filesystem_export_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'ExportResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ExportersFileExportsApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
