=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.2.3

=end

require 'cgi'

module PulpFileClient
  class ExportersFilesystemApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a file filesystem exporter
    # FilesystemExporters export content from a publication to a path on the file system.  WARNING: This feature is provided as a tech preview and may change in the future. Backwards compatibility is not guaranteed.
    # @param file_file_filesystem_exporter [FileFileFilesystemExporter] 
    # @param [Hash] opts the optional parameters
    # @return [FileFileFilesystemExporterResponse]
    def create(file_file_filesystem_exporter, opts = {})
      data, _status_code, _headers = create_with_http_info(file_file_filesystem_exporter, opts)
      data
    end

    # Create a file filesystem exporter
    # FilesystemExporters export content from a publication to a path on the file system.  WARNING: This feature is provided as a tech preview and may change in the future. Backwards compatibility is not guaranteed.
    # @param file_file_filesystem_exporter [FileFileFilesystemExporter] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(FileFileFilesystemExporterResponse, Integer, Hash)>] FileFileFilesystemExporterResponse data, response status code and response headers
    def create_with_http_info(file_file_filesystem_exporter, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ExportersFilesystemApi.create ...'
      end
      # verify the required parameter 'file_file_filesystem_exporter' is set
      if @api_client.config.client_side_validation && file_file_filesystem_exporter.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_filesystem_exporter' when calling ExportersFilesystemApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/exporters/file/filesystem/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(file_file_filesystem_exporter) 

      # return_type
      return_type = opts[:return_type] || 'FileFileFilesystemExporterResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ExportersFilesystemApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete a file filesystem exporter
    # FilesystemExporters export content from a publication to a path on the file system.  WARNING: This feature is provided as a tech preview and may change in the future. Backwards compatibility is not guaranteed.
    # @param file_file_filesystem_exporter_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete(file_file_filesystem_exporter_href, opts = {})
      delete_with_http_info(file_file_filesystem_exporter_href, opts)
      nil
    end

    # Delete a file filesystem exporter
    # FilesystemExporters export content from a publication to a path on the file system.  WARNING: This feature is provided as a tech preview and may change in the future. Backwards compatibility is not guaranteed.
    # @param file_file_filesystem_exporter_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def delete_with_http_info(file_file_filesystem_exporter_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ExportersFilesystemApi.delete ...'
      end
      # verify the required parameter 'file_file_filesystem_exporter_href' is set
      if @api_client.config.client_side_validation && file_file_filesystem_exporter_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_filesystem_exporter_href' when calling ExportersFilesystemApi.delete"
      end
      # resource path
      local_var_path = '{file_file_filesystem_exporter_href}'.sub('{' + 'file_file_filesystem_exporter_href' + '}', CGI.escape(file_file_filesystem_exporter_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ExportersFilesystemApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List file filesystem exporters
    # FilesystemExporters export content from a publication to a path on the file system.  WARNING: This feature is provided as a tech preview and may change in the future. Backwards compatibility is not guaranteed.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name name
    # @option opts [String] :name__in name__in
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [InlineResponse2002]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List file filesystem exporters
    # FilesystemExporters export content from a publication to a path on the file system.  WARNING: This feature is provided as a tech preview and may change in the future. Backwards compatibility is not guaranteed.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name name
    # @option opts [String] :name__in name__in
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(InlineResponse2002, Integer, Hash)>] InlineResponse2002 data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ExportersFilesystemApi.list ...'
      end
      # resource path
      local_var_path = '/pulp/api/v3/exporters/file/filesystem/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'name__in'] = opts[:'name__in'] if !opts[:'name__in'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'InlineResponse2002' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ExportersFilesystemApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a file filesystem exporter
    # FilesystemExporters export content from a publication to a path on the file system.  WARNING: This feature is provided as a tech preview and may change in the future. Backwards compatibility is not guaranteed.
    # @param file_file_filesystem_exporter_href [String] 
    # @param patchedfile_file_filesystem_exporter [PatchedfileFileFilesystemExporter] 
    # @param [Hash] opts the optional parameters
    # @return [FileFileFilesystemExporterResponse]
    def partial_update(file_file_filesystem_exporter_href, patchedfile_file_filesystem_exporter, opts = {})
      data, _status_code, _headers = partial_update_with_http_info(file_file_filesystem_exporter_href, patchedfile_file_filesystem_exporter, opts)
      data
    end

    # Update a file filesystem exporter
    # FilesystemExporters export content from a publication to a path on the file system.  WARNING: This feature is provided as a tech preview and may change in the future. Backwards compatibility is not guaranteed.
    # @param file_file_filesystem_exporter_href [String] 
    # @param patchedfile_file_filesystem_exporter [PatchedfileFileFilesystemExporter] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(FileFileFilesystemExporterResponse, Integer, Hash)>] FileFileFilesystemExporterResponse data, response status code and response headers
    def partial_update_with_http_info(file_file_filesystem_exporter_href, patchedfile_file_filesystem_exporter, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ExportersFilesystemApi.partial_update ...'
      end
      # verify the required parameter 'file_file_filesystem_exporter_href' is set
      if @api_client.config.client_side_validation && file_file_filesystem_exporter_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_filesystem_exporter_href' when calling ExportersFilesystemApi.partial_update"
      end
      # verify the required parameter 'patchedfile_file_filesystem_exporter' is set
      if @api_client.config.client_side_validation && patchedfile_file_filesystem_exporter.nil?
        fail ArgumentError, "Missing the required parameter 'patchedfile_file_filesystem_exporter' when calling ExportersFilesystemApi.partial_update"
      end
      # resource path
      local_var_path = '{file_file_filesystem_exporter_href}'.sub('{' + 'file_file_filesystem_exporter_href' + '}', CGI.escape(file_file_filesystem_exporter_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(patchedfile_file_filesystem_exporter) 

      # return_type
      return_type = opts[:return_type] || 'FileFileFilesystemExporterResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ExportersFilesystemApi#partial_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a file filesystem exporter
    # FilesystemExporters export content from a publication to a path on the file system.  WARNING: This feature is provided as a tech preview and may change in the future. Backwards compatibility is not guaranteed.
    # @param file_file_filesystem_exporter_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [FileFileFilesystemExporterResponse]
    def read(file_file_filesystem_exporter_href, opts = {})
      data, _status_code, _headers = read_with_http_info(file_file_filesystem_exporter_href, opts)
      data
    end

    # Inspect a file filesystem exporter
    # FilesystemExporters export content from a publication to a path on the file system.  WARNING: This feature is provided as a tech preview and may change in the future. Backwards compatibility is not guaranteed.
    # @param file_file_filesystem_exporter_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(FileFileFilesystemExporterResponse, Integer, Hash)>] FileFileFilesystemExporterResponse data, response status code and response headers
    def read_with_http_info(file_file_filesystem_exporter_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ExportersFilesystemApi.read ...'
      end
      # verify the required parameter 'file_file_filesystem_exporter_href' is set
      if @api_client.config.client_side_validation && file_file_filesystem_exporter_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_filesystem_exporter_href' when calling ExportersFilesystemApi.read"
      end
      # resource path
      local_var_path = '{file_file_filesystem_exporter_href}'.sub('{' + 'file_file_filesystem_exporter_href' + '}', CGI.escape(file_file_filesystem_exporter_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'FileFileFilesystemExporterResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ExportersFilesystemApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a file filesystem exporter
    # FilesystemExporters export content from a publication to a path on the file system.  WARNING: This feature is provided as a tech preview and may change in the future. Backwards compatibility is not guaranteed.
    # @param file_file_filesystem_exporter_href [String] 
    # @param file_file_filesystem_exporter [FileFileFilesystemExporter] 
    # @param [Hash] opts the optional parameters
    # @return [FileFileFilesystemExporterResponse]
    def update(file_file_filesystem_exporter_href, file_file_filesystem_exporter, opts = {})
      data, _status_code, _headers = update_with_http_info(file_file_filesystem_exporter_href, file_file_filesystem_exporter, opts)
      data
    end

    # Update a file filesystem exporter
    # FilesystemExporters export content from a publication to a path on the file system.  WARNING: This feature is provided as a tech preview and may change in the future. Backwards compatibility is not guaranteed.
    # @param file_file_filesystem_exporter_href [String] 
    # @param file_file_filesystem_exporter [FileFileFilesystemExporter] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(FileFileFilesystemExporterResponse, Integer, Hash)>] FileFileFilesystemExporterResponse data, response status code and response headers
    def update_with_http_info(file_file_filesystem_exporter_href, file_file_filesystem_exporter, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ExportersFilesystemApi.update ...'
      end
      # verify the required parameter 'file_file_filesystem_exporter_href' is set
      if @api_client.config.client_side_validation && file_file_filesystem_exporter_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_filesystem_exporter_href' when calling ExportersFilesystemApi.update"
      end
      # verify the required parameter 'file_file_filesystem_exporter' is set
      if @api_client.config.client_side_validation && file_file_filesystem_exporter.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_filesystem_exporter' when calling ExportersFilesystemApi.update"
      end
      # resource path
      local_var_path = '{file_file_filesystem_exporter_href}'.sub('{' + 'file_file_filesystem_exporter_href' + '}', CGI.escape(file_file_filesystem_exporter_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(file_file_filesystem_exporter) 

      # return_type
      return_type = opts[:return_type] || 'FileFileFilesystemExporterResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ExportersFilesystemApi#update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
