=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.2.3

=end

require 'cgi'

module PulpFileClient
  class RemotesFileApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a file remote
    #  FileRemote represents an external source of File Content.  The target url of a FileRemote must contain a file manifest, which contains the metadata for all files at the source.
    # @param file_file_remote [FileFileRemote] 
    # @param [Hash] opts the optional parameters
    # @return [FileFileRemoteResponse]
    def create(file_file_remote, opts = {})
      data, _status_code, _headers = create_with_http_info(file_file_remote, opts)
      data
    end

    # Create a file remote
    #  FileRemote represents an external source of File Content.  The target url of a FileRemote must contain a file manifest, which contains the metadata for all files at the source.
    # @param file_file_remote [FileFileRemote] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(FileFileRemoteResponse, Integer, Hash)>] FileFileRemoteResponse data, response status code and response headers
    def create_with_http_info(file_file_remote, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RemotesFileApi.create ...'
      end
      # verify the required parameter 'file_file_remote' is set
      if @api_client.config.client_side_validation && file_file_remote.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_remote' when calling RemotesFileApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/remotes/file/file/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(file_file_remote) 

      # return_type
      return_type = opts[:return_type] || 'FileFileRemoteResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RemotesFileApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete a file remote
    # Trigger an asynchronous delete task
    # @param file_file_remote_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def delete(file_file_remote_href, opts = {})
      data, _status_code, _headers = delete_with_http_info(file_file_remote_href, opts)
      data
    end

    # Delete a file remote
    # Trigger an asynchronous delete task
    # @param file_file_remote_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def delete_with_http_info(file_file_remote_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RemotesFileApi.delete ...'
      end
      # verify the required parameter 'file_file_remote_href' is set
      if @api_client.config.client_side_validation && file_file_remote_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_remote_href' when calling RemotesFileApi.delete"
      end
      # resource path
      local_var_path = '{file_file_remote_href}'.sub('{' + 'file_file_remote_href' + '}', CGI.escape(file_file_remote_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RemotesFileApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List file remotes
    #  FileRemote represents an external source of File Content.  The target url of a FileRemote must contain a file manifest, which contains the metadata for all files at the source.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name name
    # @option opts [String] :name__in name__in
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :pulp_last_updated pulp_last_updated
    # @option opts [String] :pulp_last_updated__gt pulp_last_updated__gt
    # @option opts [String] :pulp_last_updated__gte pulp_last_updated__gte
    # @option opts [String] :pulp_last_updated__lt pulp_last_updated__lt
    # @option opts [String] :pulp_last_updated__lte pulp_last_updated__lte
    # @option opts [String] :pulp_last_updated__range pulp_last_updated__range
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [InlineResponse2005]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List file remotes
    #  FileRemote represents an external source of File Content.  The target url of a FileRemote must contain a file manifest, which contains the metadata for all files at the source.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name name
    # @option opts [String] :name__in name__in
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :pulp_last_updated pulp_last_updated
    # @option opts [String] :pulp_last_updated__gt pulp_last_updated__gt
    # @option opts [String] :pulp_last_updated__gte pulp_last_updated__gte
    # @option opts [String] :pulp_last_updated__lt pulp_last_updated__lt
    # @option opts [String] :pulp_last_updated__lte pulp_last_updated__lte
    # @option opts [String] :pulp_last_updated__range pulp_last_updated__range
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(InlineResponse2005, Integer, Hash)>] InlineResponse2005 data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RemotesFileApi.list ...'
      end
      # resource path
      local_var_path = '/pulp/api/v3/remotes/file/file/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'name__in'] = opts[:'name__in'] if !opts[:'name__in'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'pulp_last_updated'] = opts[:'pulp_last_updated'] if !opts[:'pulp_last_updated'].nil?
      query_params[:'pulp_last_updated__gt'] = opts[:'pulp_last_updated__gt'] if !opts[:'pulp_last_updated__gt'].nil?
      query_params[:'pulp_last_updated__gte'] = opts[:'pulp_last_updated__gte'] if !opts[:'pulp_last_updated__gte'].nil?
      query_params[:'pulp_last_updated__lt'] = opts[:'pulp_last_updated__lt'] if !opts[:'pulp_last_updated__lt'].nil?
      query_params[:'pulp_last_updated__lte'] = opts[:'pulp_last_updated__lte'] if !opts[:'pulp_last_updated__lte'].nil?
      query_params[:'pulp_last_updated__range'] = opts[:'pulp_last_updated__range'] if !opts[:'pulp_last_updated__range'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'InlineResponse2005' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RemotesFileApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a file remote
    # Trigger an asynchronous partial update task
    # @param file_file_remote_href [String] 
    # @param patchedfile_file_remote [PatchedfileFileRemote] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def partial_update(file_file_remote_href, patchedfile_file_remote, opts = {})
      data, _status_code, _headers = partial_update_with_http_info(file_file_remote_href, patchedfile_file_remote, opts)
      data
    end

    # Update a file remote
    # Trigger an asynchronous partial update task
    # @param file_file_remote_href [String] 
    # @param patchedfile_file_remote [PatchedfileFileRemote] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def partial_update_with_http_info(file_file_remote_href, patchedfile_file_remote, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RemotesFileApi.partial_update ...'
      end
      # verify the required parameter 'file_file_remote_href' is set
      if @api_client.config.client_side_validation && file_file_remote_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_remote_href' when calling RemotesFileApi.partial_update"
      end
      # verify the required parameter 'patchedfile_file_remote' is set
      if @api_client.config.client_side_validation && patchedfile_file_remote.nil?
        fail ArgumentError, "Missing the required parameter 'patchedfile_file_remote' when calling RemotesFileApi.partial_update"
      end
      # resource path
      local_var_path = '{file_file_remote_href}'.sub('{' + 'file_file_remote_href' + '}', CGI.escape(file_file_remote_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(patchedfile_file_remote) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RemotesFileApi#partial_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a file remote
    #  FileRemote represents an external source of File Content.  The target url of a FileRemote must contain a file manifest, which contains the metadata for all files at the source.
    # @param file_file_remote_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [FileFileRemoteResponse]
    def read(file_file_remote_href, opts = {})
      data, _status_code, _headers = read_with_http_info(file_file_remote_href, opts)
      data
    end

    # Inspect a file remote
    #  FileRemote represents an external source of File Content.  The target url of a FileRemote must contain a file manifest, which contains the metadata for all files at the source.
    # @param file_file_remote_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(FileFileRemoteResponse, Integer, Hash)>] FileFileRemoteResponse data, response status code and response headers
    def read_with_http_info(file_file_remote_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RemotesFileApi.read ...'
      end
      # verify the required parameter 'file_file_remote_href' is set
      if @api_client.config.client_side_validation && file_file_remote_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_remote_href' when calling RemotesFileApi.read"
      end
      # resource path
      local_var_path = '{file_file_remote_href}'.sub('{' + 'file_file_remote_href' + '}', CGI.escape(file_file_remote_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'FileFileRemoteResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RemotesFileApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a file remote
    # Trigger an asynchronous update task
    # @param file_file_remote_href [String] 
    # @param file_file_remote [FileFileRemote] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def update(file_file_remote_href, file_file_remote, opts = {})
      data, _status_code, _headers = update_with_http_info(file_file_remote_href, file_file_remote, opts)
      data
    end

    # Update a file remote
    # Trigger an asynchronous update task
    # @param file_file_remote_href [String] 
    # @param file_file_remote [FileFileRemote] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def update_with_http_info(file_file_remote_href, file_file_remote, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RemotesFileApi.update ...'
      end
      # verify the required parameter 'file_file_remote_href' is set
      if @api_client.config.client_side_validation && file_file_remote_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_remote_href' when calling RemotesFileApi.update"
      end
      # verify the required parameter 'file_file_remote' is set
      if @api_client.config.client_side_validation && file_file_remote.nil?
        fail ArgumentError, "Missing the required parameter 'file_file_remote' when calling RemotesFileApi.update"
      end
      # resource path
      local_var_path = '{file_file_remote_href}'.sub('{' + 'file_file_remote_href' + '}', CGI.escape(file_file_remote_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(file_file_remote) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RemotesFileApi#update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
